Namespace Data
    'Klasse um zustzliche Informationen zum Audiostream zu speichern
    Public Class Audio
        Inherits ProjectViewItem

        Public Sub New()
        End Sub

        Public Sub New(ByVal FullPath As String, ByVal Language As Muxxi.DATA.Language)
            Me.FullPath = FullPath
            Me.Language = Language
        End Sub

        'Das bergeordnete Data.Movie Object
        Private m_movie As Data.Movie
        Public Property Movie() As Data.Movie
            Get
                Return Me.m_movie
            End Get
            Set(ByVal Value As Data.Movie)
                Me.m_movie = Value
            End Set
        End Property

        Private m_fullpath As String
        Public Property FullPath() As String
            Get
                Return Me.m_fullpath
            End Get
            Set(ByVal Value As String)
                Me.m_fullpath = Value
            End Set
        End Property

        Public ReadOnly Property FileName() As String
            Get
                Return System.IO.Path.GetFileName(FullPath)
            End Get
        End Property

        Private m_language As Muxxi.DATA.Language
        Public Property Language() As Muxxi.DATA.Language
            Get
                Return Me.m_language
            End Get
            Set(ByVal Value As Muxxi.DATA.Language)
                Me.m_language = Value
            End Set
        End Property

        Private m_infos As MultiMediaFile.AudioInfo
        Public Property Infos() As MultiMediaFile.AudioInfo
            Get
                Return Me.m_infos
            End Get
            Set(ByVal Value As MultiMediaFile.AudioInfo)
                Me.m_infos = Value
            End Set
        End Property


        'ReadOnly Eigenschaften
        Public Shadows ReadOnly Property ToString() As String
            Get
                Return String.Format("{0}: {1}", Language.Code, FileName)
            End Get
        End Property
    End Class
End Namespace