Namespace Data
    'Klasse um zustzliche Informationen zum Men zu speichern
    Public Class Menu
        Inherits ProjectViewItem

        Public Sub New()

        End Sub

        Public Sub New(ByVal Name As String, ByVal Title As String)
            Initialize()

            Me.m_name = Name
            Me.m_title = Title
        End Sub

        Private Sub Initialize()
            Me.m_buttons = New ArrayList
            Me.m_normalcolor = Settings.DVDMenu.NormalColor
            Me.m_selectedcolor = Settings.DVDMenu.SelectColor
            Me.m_highlightcolor = Settings.DVDMenu.HighlightColor
        End Sub

        'Das bergeordnete Data.Project Object
        Private m_project As Data.Project
        Public Property Project() As Data.Project
            Get
                Return Me.m_project
            End Get
            Set(ByVal Value As Data.Project)
                Me.m_project = Value
            End Set
        End Property

        'Der Men-Name, welcher zur Identifikation im Verarbeitungsablauf verwendet wird
        Private m_name As String
        Public Property Name() As String
            Get
                Return Me.m_name
            End Get
            Set(ByVal Value As String)
                Me.m_name = Value
            End Set
        End Property

        'Die berschrift
        Private m_title As String
        Public Property Title() As String
            Get
                Return Me.m_title
            End Get
            Set(ByVal Value As String)
                Me.m_title = Value
            End Set
        End Property

        'Verweis auf das Hintergrund-Bild
        Private m_backgroundfile As String
        Public Property BackgroundFile() As String
            Get
                Return Me.m_backgroundfile
            End Get
            Set(ByVal Value As String)
                Me.m_backgroundfile = Value
            End Set
        End Property

        'Verwendete Farben
        'Standard-Farbe
        Private m_normalcolor As Color
        Public Property NormalColor() As Color
            Get
                Return Me.m_normalcolor
            End Get
            Set(ByVal Value As Color)
                Me.m_normalcolor = Value
            End Set
        End Property

        'Farbe zur Darstellung eines Buttons, der markiert wurde
        Public m_highlightcolor As Color
        Public Property HighlightColor() As Color
            Get
                Return Me.m_highlightcolor
            End Get
            Set(ByVal Value As Color)
                Me.m_highlightcolor = Value
            End Set
        End Property

        'Farbe zur Darstellung eines Buttons, der ausgewhlt wurde
        Public m_selectedcolor As Color
        Public Property SelectedColor() As Color
            Get
                Return Me.m_selectedcolor
            End Get
            Set(ByVal Value As Color)
                Me.m_selectedcolor = Value
            End Set
        End Property


        'Auflistung aller MenuButtons
        Private m_buttons As ArrayList
        Public ReadOnly Property Buttons(ByVal Index As Integer) As MenuButtonBase
            Get
                Return DirectCast(Me.m_buttons(Index), MenuButtonBase)
            End Get
        End Property

        Public ReadOnly Property Buttons() As ArrayList
            Get
                Return Me.m_buttons
            End Get
        End Property
    End Class


    'Grundgerst eines Buttons
    Public MustInherit Class MenuButtonBase
        Public Sub New(ByVal Name As String)
            Initialize()

            Me.Name = Name
        End Sub

        Private Sub Initialize()
            Me.AlphaNormal = &HFF
            Me.AlphaHighlight = &HFF
            Me.AlphaSelected = &HFF
        End Sub

        'Name der Buttons zur besseren Identifizierung
        'in DVDauthor
        Private m_name As String
        Public Property Name() As String
            Get
                Return Me.m_name
            End Get
            Set(ByVal Value As String)
                Me.m_name = Value
            End Set
        End Property

        'Name des Objektes, welches durch diesen Button erreicht werden soll
        Private m_linkto As String
        Public Property LinkTo() As String
            Get
                Return Me.m_linkto
            End Get
            Set(ByVal Value As String)
                Me.m_linkto = Value
            End Set
        End Property

        'Gre des MenuButtons als Width, Height und Size
        Private m_width As Integer
        Public Property Width() As Integer
            Get
                Return Me.m_width
            End Get
            Set(ByVal Value As Integer)
                Me.m_width = Value
            End Set
        End Property

        Private m_height As Integer
        Public Property Height() As Integer
            Get
                Return Me.m_height
            End Get
            Set(ByVal Value As Integer)
                Me.m_height = Value
            End Set
        End Property

        Public Property Size() As System.Drawing.Size
            Get
                Return New System.Drawing.Size(Me.Width, Me.Height)
            End Get
            Set(ByVal Value As System.Drawing.Size)
                Me.Width = Value.Width
                Me.Height = Value.Height
            End Set
        End Property

        'Position des Buttons als X, Y und Location
        Private m_x As Integer
        Public Property X() As Integer
            Get
                Return Me.m_x
            End Get
            Set(ByVal Value As Integer)
                Me.m_x = Value
            End Set
        End Property

        Private m_y As Integer
        Public Property Y() As Integer
            Get
                Return Me.m_y
            End Get
            Set(ByVal Value As Integer)
                Me.m_y = Value
            End Set
        End Property

        Public Property Location() As System.Drawing.Point
            Get
                Return New System.Drawing.Point(Me.X, Me.Y)
            End Get
            Set(ByVal Value As System.Drawing.Point)
                Me.X = Value.X
                Me.Y = Value.Y
            End Set
        End Property

        'Transparenz der NormalColor
        Private m_alphanormal As Byte
        Public Property AlphaNormal() As Byte
            Get
                Return Me.m_alphanormal
            End Get
            Set(ByVal Value As Byte)
                Me.m_alphanormal = Value
            End Set
        End Property

        'Transparend der HighlightColor
        Private m_alphahighlight As Byte
        Public Property AlphaHighlight() As Byte
            Get
                Return Me.m_alphahighlight
            End Get
            Set(ByVal Value As Byte)
                Me.m_alphahighlight = Value
            End Set
        End Property

        'Transparenz der SelectedColor
        Private m_alphaselected As Byte
        Public Property AlphaSelected() As Byte
            Get
                Return Me.m_alphaselected
            End Get
            Set(ByVal Value As Byte)
                Me.m_alphaselected = Value
            End Set
        End Property
    End Class


    Public Class TextButton
        Inherits MenuButtonBase

        Public Sub New(ByVal Name As String, ByVal Text As String)
            MyBase.new(Name)
            Me.m_text = Text
        End Sub

        'Text, der auf dem TextButton angezeigt werden soll
        Private m_text As String
        Public Property Text() As String
            Get
                Return Me.m_text
            End Get
            Set(ByVal Value As String)
                Me.m_text = Value
            End Set
        End Property
    End Class


    Public Class PictureButton
        Inherits MenuButtonBase

        Public Sub New(ByVal Name As String, ByVal Image As Bitmap)
            MyBase.new(Name)
            Me.m_image = Image
        End Sub

        'Bild aus dem der PictureButton bestehen soll
        Private m_image As Bitmap
        Public Property Image() As Bitmap
            Get
                Return Me.m_image
            End Get
            Set(ByVal Value As Bitmap)
                Me.m_image = Value
            End Set
        End Property
    End Class
End Namespace