Imports System.IO

Namespace Data
    Public Class Movie
        Inherits ProjectViewItem
        'Inherits ComponentModel.ProjectTreeComponent

        Public Sub New()
            m_audios = New AudioCollection(Me)
            m_video = New Data.Video(Me)
            Me.Text = "Neuer Film"
        End Sub

        'Das bergeordnete Data.Project Object
        Private m_project As Data.Project
        Public Property Project() As Data.Project
            Get
                Return Me.m_project
            End Get
            Set(ByVal Value As Data.Project)
                Me.m_project = Value
            End Set
        End Property

        'Bezeichnung des Filmes
        Private m_text As String
        Public Shadows Property Text() As String
            Get
                Return Me.m_text
            End Get
            Set(ByVal Value As String)
                Me.m_text = Value
            End Set
        End Property

        'Stammverzeichnis des zu verarbeitenden Filmes
        Private m_inputfolder As String
        Public Property InputFolder() As String
            Get
                Return Me.m_inputfolder
            End Get
            Set(ByVal Value As String)
                Me.m_inputfolder = Value
            End Set
        End Property

        'Pfad zur LOG-Datei von JackTheGrabber
        Private m_jacklog As String
        Public Property JackLog() As String
            Get
                Return Me.m_jacklog
            End Get
            Set(ByVal Value As String)
                Me.m_jacklog = Value
            End Set
        End Property

        'Einstellungen zum Movie
        Private m_video As Data.Video
        Public Property Video() As Data.Video
            Get
                Return m_video
            End Get
            Set(ByVal Value As Data.Video)
                m_video = Value
            End Set
        End Property

        Private m_audios As AudioCollection

        Public FilmLength As Int16 = Settings.DVD.FilmLength
        Public ChapterLength As Int16 = Settings.DVD.ChapterLength
        Public ChapterDialog As String = String.Empty

        Public GenerateIDD As Boolean = Settings.Udrec.GenerateIDD
        Public VSplit As Int16 = Settings.Udrec.VSplit
        Public ASplit As Int16 = Settings.Udrec.ASplit

        'Variablen zur richtigen Verarbeitung bei der automatischen Abwicklung
        Public InputType As Data.InputType

        'Eigenschaften um Zugriff auf die einzelnen Variablen zu erhalten
        Public WriteOnly Property SetVideoFile() As String
            Set(ByVal Value As String)
                Me.Video.FullPath = Value
                'Me.VideoFrameInfo = MPEGDecoder.MPEG2Video.GetFrameInfo(Video)
                Me.InputFolder = New System.IO.FileInfo(Value).DirectoryName
                Me.Text = Me.GetBaseName
            End Set
        End Property

        Public ReadOnly Property OnlyVideo() As Boolean
            Get
                If Audios.Count = 0 Then
                    Return True
                Else
                    Return False
                End If
            End Get
        End Property

        Public ReadOnly Property Audios() As AudioCollection
            Get
                Return m_audios
            End Get
        End Property

        Public Sub AddAudio(ByVal AudioStream As Audio)
            Audios.Add(AudioStream)
        End Sub


        Public ReadOnly Property GetMovieSize() As Int16
            Get
                Dim Size As Int16
                Size = (New System.IO.FileInfo(Video.FullPath).Length) / (1024 ^ 2)

                For Each Audio As Data.Audio In Audios
                    Size += (New System.IO.FileInfo(Audio.FullPath).Length) / (1024 ^ 2)
                Next

                Return Size
            End Get
        End Property

        Private Function GetBaseName() As String
            Dim VideoFileName As String = System.IO.Path.GetFileNameWithoutExtension(Me.Video.FullPath)
            Dim pos As Int16 = InStr(VideoFileName, "-1_", CompareMethod.Binary)

            If pos = 0 Then
                Return VideoFileName
            Else
                Return Mid(VideoFileName, 1, pos - 1)
            End If
        End Function

        Public Sub GetAudioStreams(ByVal Folder As String)
            Dim Path As New System.IO.DirectoryInfo(Folder)
            Dim Files() As String
            Dim RecStreams As Settings.Automatical.Recorded

            OUTPUT.LOG.WriteLine("Ermittle zu verwendende Audio-Dateien...", Images.Icon.Info)

            'Es wird versucht ein vorhandenes JtG-LOG zu ffnen
            'um festzustellen, welche PID's gestreamt wurden
            If Me.JackLog Is String.Empty Then
                OUTPUT.LOG.WriteLine("Keine 'Jack The Grabber' LOG-Datei gefunden", Images.Icon.Error)
                OUTPUT.LOG.WriteLine("Standard Einstellungen werden verwendet", Images.Icon.None)
            Else

                OUTPUT.LOG.WriteLine("Versuche 'Jack The Grabber' LOG-Datei zu ffnen", Images.Icon.Info)
                Try
                    Dim strLOG As New StreamReader(Me.JackLog, System.Text.Encoding.Default)
                    Dim strRow As String

                    While (strLOG.Peek() > -1)
                        ' Auslesen der einzelnen Zeilen aus der Playlist
                        strRow = strLOG.ReadLine()

                        If strRow Like "*: Audio1: *" Then
                            Dim i As Int16

                            For i = 1 To 3
                                If Not (Mid(strRow, 20)) = 0 Then
                                    Select Case Microsoft.VisualBasic.Right(Hex(Mid(strRow, 20)), 1)
                                        Case 0
                                            OUTPUT.LOG.WriteLine("Standard MP2-Audio wurde aufgenommen", Images.Icon.Audio)
                                            RecStreams += Settings.Automatical.Recorded.Standard
                                        Case 1
                                            OUTPUT.LOG.WriteLine("Original MP2-Audio wurde aufgenommen", Images.Icon.Audio)
                                            RecStreams += Settings.Automatical.Recorded.Original
                                        Case 3
                                            OUTPUT.LOG.WriteLine("Standard AC3-Audio wurde aufgenommen", Images.Icon.Audio)
                                            RecStreams += Settings.Automatical.Recorded.AC3
                                        Case Else
                                            OUTPUT.LOG.WriteLine("Original MP2-Audio wurde aufgenommen", Images.Icon.Audio)
                                            RecStreams += Settings.Automatical.Recorded.Standard
                                    End Select
                                End If

                                strRow = strLOG.ReadLine()
                            Next

                            Exit While
                        End If
                    End While

                    strLOG.Close()
                Catch
                    OUTPUT.LOG.WriteLine("LOG-Datei konnte nicht verarbeitet werden", Images.Icon.Error)
                    OUTPUT.LOG.WriteLine("Standard Einstellungen werden verwendet", Images.Icon.None)
                End Try
            End If

            'Es wird der Dateiname ohne Endung aus 'FileName' extrahiert
            Dim BaseName As String = System.IO.Path.GetFileNameWithoutExtension(Me.Video.FullPath)

            'Dies ist der String, nach dem im Verzeichnis 'Path' gesucht wird
            'wobei die drei letzten Stellen entfernt werden, da diese die
            'Anzahl angeben.
            Dim SearchString As String

            Select Case Me.InputType
                Case Data.InputType.PX_PES
                    SearchString = Microsoft.VisualBasic.Left(BaseName, BaseName.Length - 2) & "??"
                Case Data.InputType.PX_ES
                    SearchString = Microsoft.VisualBasic.Left(BaseName, BaseName.Length - 4) & "??_0"
                Case Else
                    SearchString = Microsoft.VisualBasic.Left(BaseName, BaseName.Length - 2) & "*" 'war vorher "??"
            End Select

            OUTPUT.LOG.WriteLine("Es wird nach folgendem String in Audio-Dateien gesucht:", Images.Icon.Info)
            OUTPUT.LOG.WriteLine(SearchString, Images.Icon.None)

            'Es werden alle AC3 Dateien aufgelistet,
            'welche im DateiNamen den SearchString enthalten
            Files = Functions.GetFiles(Path, SearchString & ".ac3")

            OUTPUT.LOG.WriteLine("Anzahl der gefundenen AC3 Dateien: " & Files.Length, Images.Icon.Input)

            'Bestimmt ob ein AC3 (Dolby Digital) AudioStream existiert,
            'dieser hat dann immer die Standard-Sprache
            Dim AC3Exists As Boolean = False

            Select Case Settings.Automatical.ProcessAudio
                Case 4, 5, 6, 7 'AC3 soll verarbeitet werden
                    For Each File As String In Files
                        Me.AddAudio(New Data.Audio(File, LanguageList.Standard))
                        AC3Exists = True
                    Next
            End Select

            'Es werden alle MP2 Dateien aufgelistet,
            'welche im DateiNamen den SearchString enthalten
            Files = Functions.GetFiles(Path, SearchString & ".mp2")

            OUTPUT.LOG.WriteLine("Anzahl der gefundenen MP2 Dateien: " & Files.Length, Images.Icon.Input)
            OUTPUT.LOG.EmptyLine()

            Select Case RecStreams
                Case 2, 6 'Es wurde keine Standard aber die Original Audiospur aufgezeichnet
                    Select Case Files.Length
                        Case 1
                            Select Case Settings.Automatical.ProcessAudio
                                Case 2, 3, 6, 7 'Es soll die Original Spur verarbeitet werden
                                    Me.AddAudio(New Data.Audio(Files(0), LanguageList.Original))
                            End Select
                    End Select
                Case Else
                    'Nun wird die Anzahl der MP2 Dateien geprft
                    Select Case Files.Length
                        Case 1
                            Select Case Settings.Automatical.ProcessAudio
                                Case 5, 7 'MP2 und AC3 wurden ausgewhlt
                                    If Not Settings.Automatical.ReplaceMP2 _
                                    OrElse (Settings.Automatical.ReplaceMP2 AndAlso Not AC3Exists) Then
                                        Me.AddAudio(New Data.Audio(Files(0), LanguageList.Standard))
                                    End If
                                Case 1, 3 'MP2 wurde AC3 wurde nicht ausgewhlt
                                    Me.AddAudio(New Data.Audio(Files(0), LanguageList.Standard))
                            End Select
                        Case 2
                            'Verarbeitung der MP2-Standard Audiospur
                            Select Case Settings.Automatical.ProcessAudio
                                Case 5, 7 'MP2 und AC3 wurden ausgewhlt
                                    If Not Settings.Automatical.ReplaceMP2 _
                                    OrElse (Settings.Automatical.ReplaceMP2 AndAlso Not AC3Exists) Then
                                        Me.AddAudio(New Data.Audio(Files(0), LanguageList.Standard))
                                    End If
                                Case 1, 3 'MP2 wurde AC3 wurde nicht ausgewhlt
                                    Me.AddAudio(New Data.Audio(Files(0), LanguageList.Standard))
                            End Select

                            'Verarbeitung der MP2-Original Audiospur
                            Select Case Settings.Automatical.ProcessAudio
                                Case 2, 3, 6, 7 'Es soll die Original Spur verarbeitet werden
                                    Me.AddAudio(New Data.Audio(Files(1), LanguageList.Original))
                            End Select
                    End Select
            End Select
        End Sub

        Public Extended As Boolean = True

        Public Shadows ReadOnly Property IsMouseDown(ByVal e As MouseEventArgs) As Boolean
            Get
                If (e.X >= Bounds.X) AndAlso (e.X <= Bounds.X + Bounds.Width) AndAlso (e.Y >= Bounds.Y) AndAlso (e.Y <= Bounds.Y + Bounds.Height) Then
                    If (e.X <= Bounds.X + 16) Then Me.Extended = Not Extended

                    Return True
                End If
                Return False
            End Get
        End Property


    End Class
End Namespace
