Namespace Data
    'Klasse um zustzliche Informationen zur Video-Datei zu speichern
    Public Class Video
        Inherits ProjectViewItem

        Public Sub New()

        End Sub

        Public Sub New(ByVal Owner As Data.Movie)
            Me.Movie = Owner
        End Sub

        'Das bergeordnete Data.Movie Object
        Private m_movie As Data.Movie
        Public Property Movie() As Data.Movie
            Get
                Return Me.m_movie
            End Get
            Set(ByVal Value As Data.Movie)
                Me.m_movie = Value
            End Set
        End Property

        'Kompletter Verweis auf die Video-Datei inkl. Pfadangabe
        Private m_fullpath As String
        Public Property FullPath() As String
            Get
                Return Me.m_fullpath
            End Get
            Set(ByVal Value As String)
                Me.m_fullpath = Value
            End Set
        End Property

        'Name der Video-Datei ohne Pfad
        Public ReadOnly Property FileName() As String
            Get
                Return System.IO.Path.GetFileName(Me.m_fullpath)
            End Get
        End Property

        'Angabe des Verzeichnises in dem die Video-Datei liegt
        Public ReadOnly Property DirectoryName() As String
            Get
                Return New System.IO.FileInfo(Me.m_fullpath).DirectoryName
            End Get
        End Property

        'Erweiterte Infos zur Video-Datei wie Auflsung, FPS, Seitenverhltnis, usw...
        Private m_infos As MultiMediaFile.VideoInfo
        Public Property Infos() As MultiMediaFile.VideoInfo
            Get
                Return Me.m_infos
            End Get
            Set(ByVal Value As MultiMediaFile.VideoInfo)
                Me.m_infos = Value
            End Set
        End Property
    End Class
End Namespace