Public Class Functions
    'Funktionen, die zur Verarbeitung  bentigt werden 
    Public Shared Function GetLegalFilename(ByVal FileName As String) As String
        Dim CharList() As Char = {"\", "/", "*", ":", "?", """", "<", ">", "|"}
        Dim illChar As Char

        For Each illChar In CharList
            FileName = Replace(FileName, illChar, "_")
        Next

        Return FileName
    End Function

    Public Shared Function GetFiles(ByVal di As System.IO.DirectoryInfo, ByVal searchMask As String) As String()
        Dim Masks() As String = Split(searchMask, ";")
        Dim Files As New ArrayList

        For Each Mask As String In masks
            For Each File As System.IO.FileInfo In di.GetFiles(mask.Trim())
                files.Add(File.FullName)
            Next
        Next
        files.Sort()
        Return files.ToArray(GetType(String))
    End Function

    Public Shared Function GetFolders(ByVal di As System.IO.DirectoryInfo) As String()
        Dim Folders As New ArrayList

        For Each Folder As System.IO.DirectoryInfo In di.GetDirectories
            If Folder.Attributes = IO.FileAttributes.Directory Then
                Folders.Add(Folder.FullName)
            End If
        Next
        Folders.Sort()
        Return Folders.ToArray(GetType(String))
    End Function

    Public Shared Function GetVideoFile(ByVal Movie As DATA.Movie) As Boolean
        If System.IO.Directory.Exists(Movie.Video.FullPath) Then
            Console.WriteLine("Bitte geben Sie einen Dateinamen und keinen Pfad an!", Images.Icon.Error)
            Console.WriteLine("-i " & Movie.Video.FullPath, Images.Icon.None)
            Exit Function
        End If

        Dim Path As New System.IO.DirectoryInfo(New System.IO.FileInfo(Movie.Video.FullPath).DirectoryName)

        'Es wird der Dateiname ohne Endung aus 'FileName' extrahiert
        Dim BaseName As String = System.IO.Path.GetFileNameWithoutExtension(Movie.Video.FullPath)

        'Dies ist der String, nach dem im Verzeichnis 'Path' gesucht wird
        'wobei die drei letzten Stellen entfernt werden, da diese die
        'Anzahl angeben.
        Dim SearchString As String = Left(BaseName, BaseName.Length - 3)

        'Es wird geprft ob es sich bei der Datei um einen PES-Film handelt
        Select Case System.IO.Path.GetExtension(Movie.Video.FullPath)
            Case ".mpv"
                Movie.InputType = DATA.InputType.ES

            Case ".vpes"
                Movie.InputType = DATA.InputType.PES

            Case ".mpg", ".ts"
                Movie.InputType = DATA.InputType.MPG
        End Select

        'Es wird geprft, ob Dateien im Verzeichnis existieren, die durch
        'eine Bearbeitung mit Project-X entstanden sind
        Dim Files As System.IO.FileInfo()

        Select Case Movie.InputType
            Case DATA.InputType.PES
                Files = Path.GetFiles(SearchString & "*_00.mpv")
            Case DATA.InputType.ES
                Files = Path.GetFiles(SearchString & "*_0.mpv")
            Case DATA.InputType.MPG
                Files = Path.GetFiles(SearchString & "*.mpv")
        End Select

        If Files.Length = 0 Then
            If Movie.InputType = DATA.InputType.MPG Then Return False
            Movie.SetVideoFile = Movie.Video.FullPath
        Else
            Select Case Movie.InputType
                Case DATA.InputType.PES
                    Movie.InputType = DATA.InputType.PX_PES
                Case DATA.InputType.ES
                    Movie.InputType = DATA.InputType.PX_ES
                Case DATA.InputType.MPG
                    Movie.InputType = DATA.InputType.PX_MPG
            End Select

            'Es werden alle MPV Dateien aufgelistet,
            'welche im DateiNamen den SearchString enthalten
            Select Case Movie.InputType
                Case DATA.InputType.PES, DATA.InputType.PX_PES
                    Files = Path.GetFiles(SearchString & "*_00.mpv")
                Case DATA.InputType.ES, DATA.InputType.PX_ES
                    Files = Path.GetFiles(SearchString & "*_0.mpv")
                Case DATA.InputType.PX_MPG
                    Files = Path.GetFiles(SearchString & "*.mpv")
            End Select

            For Each File As System.IO.FileInfo In Files
                Movie.SetVideoFile = File.FullName
            Next
        End If

        Return True
    End Function

    'Diverse Funktionen, die genutzt werden
    Public Shared Function EndTime(ByVal StartTime As Date) As String
        Return Now.Subtract(StartTime).ToString
    End Function

End Class