Imports System.IO

Public Class Main
    Public Shared Sub Main(ByVal args As String())
        'XP-Styles aktivieren
        'Application.EnableVisualStyles()
        'Application.DoEvents()
        Threading.Thread.CurrentThread.Name = "UI-Thread"
        'Dim args() As String = {"-i", "E:\2004-06-14-xXx - Triple X (xXx)\xXx - Triple X (xXx)(PREMIERE 2)-1_00.vpes", "-o", "e:\Test", "-out", "MPG", "-vsplit", "2"}
        'Dim args() As String = {"-i", "E:\2004-06-15-Lost Heaven\Lost Heaven(PREMIERE 2)-1[01].mpg", "-out", "MPG", "-vsplit", "2"}
        'Dim args() As String = {"-i", "E:\2004-06-17-The Abduction Club - Entfuehrer & Gentlemen\The Abduction Club - Entfuehrer & Gentlemen-1_00.vpes", "-out", "DVD"}


        'Es werden die notwendigen Initialiiserungen durchgefhrt
        'um alle Einstellungen zu laden
        Muxxi.DATA.LanguageList.Load()
        Settings.Functions.Read()

        'Wurde Muxxi mit Parametern gestartet?
        If args.Length = 0 Then

            Do
                Dim StreamSelection As New UI.ProjectDialog
                Select Case StreamSelection.ShowDialog
                    Case DialogResult.OK
                        OUTPUT.LOG.LogDialog = New UI.LogDialog
                        Application.Run(OUTPUT.LOG.LogDialog)
                    Case Else
                        Call Dispose()
                        Exit Sub
                End Select
            Loop
        Else

            'Im automatischen Modus wird kein LOG-Dialog angezeigt
            Settings.Automatical.Modus = True

            Dim Project As New Data.Project
            Dim Movie As New Data.Movie

            Project.AddMovie(Movie)

            Console.WriteLine("Muxxi wurde mit foldenden Parametern gestartet:")

            For Each arg As String In args
                Console.WriteLine(arg)
            Next

            Console.WriteLine()

            Dim Argument As String

            Try

                Dim i As Integer = 0
                While i < args.Length

                    If args(i) = "-i" Then
                        i += 1
                        Argument = args(i)
                        If args.Length = 0 Then
                        Else
                            Movie.Video.FullPath = Argument
                            If Not Functions.GetVideoFile(Movie) Then
                                Console.WriteLine("MPG-Dateien knnen nicht verarbeitet werden!")
                                Exit Sub
                            End If
                        End If

                    ElseIf args(i) = "-o" Then
                        i += 1
                        Argument = args(i)
                        If args.Length = 0 Then
                        Else
                            Settings.Output.Folder = Argument
                        End If

                    ElseIf args(i) = "-chapter" Then
                        i += 1
                        Argument = args(i)
                        If Argument.Length = 0 Or Argument.StartsWith("-") Then
                            Movie.ChapterLength = 0
                        Else
                            Movie.ChapterLength = Argument
                        End If

                    ElseIf args(i) = "-out" Then
                        i += 1
                        Argument = args(i)
                        Select Case Argument.ToUpper
                            Case "ES"
                                Project.Type = DATA.ProjectType.ES
                            Case "MPG"
                                Project.Type = DATA.ProjectType.MPG
                            Case "DVD"
                                Project.Type = DATA.ProjectType.DVD
                            Case "VOB"
                                Project.Type = DATA.ProjectType.VOB
                        End Select

                    ElseIf args(i) = "-vsplit" Then
                        If Not args.Length = i Then
                            Select Case args(i + 1)
                                Case 0 To 5
                                    i += 1
                                    Argument = args(i)
                                    Movie.VSplit = Argument
                                Case Else
                                    Movie.VSplit = -1
                            End Select
                        End If

                    ElseIf args(i) = "-asplit" Then
                        If Not args.Length = i Then
                            Select Case args(i + 1)
                                Case 0 To 5
                                    i += 1
                                    Argument = args(i)
                                    Movie.ASplit = Argument
                                Case Else
                                    Movie.ASplit = -1
                            End Select
                        End If
                    End If

                    i += 1
                End While

            Catch ex As Exception 'generatedExceptionVariable0 As FormatException
                Console.WriteLine("Es ist ein Fehler aufgetreten!")
                Console.WriteLine(ex.ToString)

                OUTPUT.LOG.LogDialog.Complete()

                Exit Sub
            End Try

            Project.SetOutput(Movie)
            Project.Text = String.Format("{0} {1:yyyy-MM-dd}", Movie.Text, Now)

            If File.Exists(Settings.Programm.XMLBatchFile) Then
                OUTPUT.XMLBatchFile.AddProject(Project, Settings.Programm.XMLBatchFile, OUTPUT.XMLBatchFile.Position.Last)
            Else
                OUTPUT.XMLBatchFile.Save(Project, Settings.Programm.XMLBatchFile)
                OUTPUT.LOG.LogDialog = New UI.LogDialog
                OUTPUT.LOG.LogDialog.SaveAndClose = True
                Application.Run(OUTPUT.LOG.LogDialog)
            End If
        End If
        Dispose()
    End Sub

    Private Shared Sub Dispose()
        Images.List.Dispose()
    End Sub
End Class
