
Public Class MessageDialog

#Region " Alle mglichen Show-Routinen zur Anzeige des"
    Private Shared MessageDialog As MessageDialog.Dialog
    Public Shared Shadows Function Show(ByVal Message As String, ByVal Buttons As MessageButtonEnum) As MessageResultEnum
        Return Show(Message, Buttons, MessageIconEnum.None)
    End Function

    Public Shared Shadows Function Show(ByVal Message As String, ByVal Buttons As MessageButtonEnum, ByVal MessageIcon As MessageIconEnum) As MessageResultEnum
        Return Show(Message, Buttons, MessageIcon, False)
    End Function

    Public Shared Shadows Function Show(ByVal Message As String, ByVal Buttons As MessageButtonEnum, ByVal MessageIcon As MessageIconEnum, ByVal SameAnswer As Boolean) As MessageResultEnum
        Return Show(Message, Settings.Programm.Name, Buttons, MessageIcon, SameAnswer)
    End Function

    Public Shared Shadows Function Show(ByVal Message As String, ByVal Caption As String, ByVal Buttons As MessageButtonEnum, ByVal MessageIcon As MessageIconEnum, ByVal SameAnswer As Boolean) As MessageResultEnum
        MessageDialog = New MessageDialog.Dialog

        MessageDialog.PaintDialog(Message, Caption, Buttons, MessageIcon, SameAnswer)
        MessageDialog.ShowDialog()

        Return MessageDialog.Result
    End Function

    Public Shared ReadOnly Property ShowAgain() As Boolean
        Get
            Return MessageDialog.cbxSameAnswer.Checked
        End Get
    End Property
#End Region

#Region " Der MessageDialog, der angezeigt wirde"
    Private Class Dialog
        Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "
        Public Sub New()
            MyBase.New()

            ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
            InitializeComponent()

            ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
        End Sub

        ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        ' Fr Windows Form-Designer erforderlich
        Private components As System.ComponentModel.IContainer

        'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
        'Sie kann mit dem Windows Form-Designer modifiziert werden.
        'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
        Private WithEvents lblText As System.Windows.Forms.Label
        Private WithEvents Picture As System.Windows.Forms.PictureBox
        Friend WithEvents cbxSameAnswer As System.Windows.Forms.CheckBox
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.lblText = New System.Windows.Forms.Label
            Me.Picture = New System.Windows.Forms.PictureBox
            Me.cbxSameAnswer = New System.Windows.Forms.CheckBox
            Me.SuspendLayout()
            '
            'lblText
            '
            Me.lblText.BackColor = System.Drawing.SystemColors.Control
            Me.lblText.Location = New System.Drawing.Point(64, 16)
            Me.lblText.Name = "lblText"
            Me.lblText.Size = New System.Drawing.Size(328, 40)
            Me.lblText.TabIndex = 0
            '
            'Picture
            '
            Me.Picture.Location = New System.Drawing.Point(16, 16)
            Me.Picture.Name = "Picture"
            Me.Picture.Size = New System.Drawing.Size(32, 32)
            Me.Picture.TabIndex = 1
            Me.Picture.TabStop = False
            '
            'cbxSameAnswer
            '
            Me.cbxSameAnswer.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.cbxSameAnswer.Location = New System.Drawing.Point(8, 80)
            Me.cbxSameAnswer.Name = "cbxSameAnswer"
            Me.cbxSameAnswer.Size = New System.Drawing.Size(120, 24)
            Me.cbxSameAnswer.TabIndex = 2
            Me.cbxSameAnswer.Text = "Nicht erneut fragen"
            '
            'Dialog
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(402, 104)
            Me.ControlBox = False
            Me.Controls.Add(Me.cbxSameAnswer)
            Me.Controls.Add(Me.Picture)
            Me.Controls.Add(Me.lblText)
            Me.ShowInTaskbar = False
            Me.StartPosition = FormStartPosition.CenterScreen
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
            Me.MaximizeBox = False
            Me.MinimizeBox = False
            Me.Name = "Dialog"
            Me.Text = "Dialog"
            Me.ResumeLayout(False)
        End Sub

#End Region

#Region " Eigenschaften und Variablen zur Verwaltung"
        Private Exclamation As New System.Drawing.Bitmap(GetType(Main), "Exclamation32x32.png")
        Private Information As New System.Drawing.Bitmap(GetType(Main), "Information32x32.png")
        Private Question As New System.Drawing.Bitmap(GetType(Main), "Question32x32.png")
        Private [Stop] As New System.Drawing.Bitmap(GetType(Main), "Stop32x32.png")

        Public Result As MessageResultEnum

        Private Property Caption() As String
            Get
                Return Me.Text
            End Get
            Set(ByVal Value As String)
                Me.Text = Value
            End Set
        End Property

        Private Property Message() As String
            Get
                Return Me.lblText.Text
            End Get
            Set(ByVal Value As String)
                Me.lblText.Text = Value
            End Set
        End Property
#End Region

#Region " Ereignisse und Funktionen welche Buttons betreffen"
        Private Buttons As New ArrayList

        Private HDistance As Int16 = 6
        Private VDistance As Int16 = 11
        Private ButtonHeight As Int16 = 23
        Private ButtonWidth As Int16 = 75

        Private SameAnswer As Boolean
        Private MessageIcon As MessageIconEnum
        Private MessageButtons As MessageButtonEnum


        Public Sub PaintDialog(ByVal Message As String, ByVal Caption As String, ByVal MessageButtons As MessageButtonEnum, ByVal MessageIcon As MessageIconEnum, ByVal SameAnswer As Boolean)
            Me.cbxSameAnswer.Checked = False

            Me.Message = Message
            Me.Caption = Caption

            Dim e As New PaintEventArgs(Me.CreateGraphics, Me.DisplayRectangle)
            Dim TextSize As SizeF = e.Graphics.MeasureString(Message, Me.lblText.Font)

            Me.lblText.Size = New System.Drawing.Size(TextSize.Width + 1, TextSize.Height + 1)

            Dim FormWidth As Int16 = TextSize.Width + 32
            Dim FormHeight As Int16 = TextSize.Height + 55

            Select Case SameAnswer
                Case True
                    Me.VDistance = 24
                    Me.cbxSameAnswer.Visible = True
                    Me.cbxSameAnswer.Location = New System.Drawing.Point(16, FormHeight)
                Case False
                    Me.VDistance = 11
                    Me.cbxSameAnswer.Visible = False
            End Select

            FormHeight += Me.VDistance

            Select Case MessageIcon
                Case MessageIconEnum.None
                    Me.lblText.Location = New System.Drawing.Point(16, 16)
                    Me.Picture.Visible = False

                Case MessageIconEnum.Exclamation
                    Me.Picture.Image = Me.Exclamation
                    FormWidth += 48

                Case MessageIconEnum.Information
                    Me.Picture.Image = Me.Information
                    FormWidth += 48

                Case MessageIconEnum.Question
                    Me.Picture.Image = Me.Question
                    FormWidth += 48

                Case MessageIconEnum.Stop
                    Me.Picture.Image = Me.Stop
                    FormWidth += 48
            End Select

            Me.ClientSize = New System.Drawing.Size(FormWidth, FormHeight)

            Select Case MessageButtons
                Case MessageButtonEnum.OneMany
                    Me.AddButton(MessageResultEnum.One)
                    Me.AddButton(MessageResultEnum.Many)

                Case MessageButtonEnum.AddOneMany
                    Me.AddButton(MessageResultEnum.Add)
                    Me.AddButton(MessageResultEnum.One)
                    Me.AddButton(MessageResultEnum.Many)

                Case MessageButtonEnum.AddOne
                    Me.AddButton(MessageResultEnum.Add)
                    Me.AddButton(MessageResultEnum.One)

                Case MessageButtonEnum.Ok
                    Me.AddButton(MessageResultEnum.OK)

                Case MessageButtonEnum.OkCancel
                    Me.AddButton(MessageResultEnum.OK)
                    Me.AddButton(MessageResultEnum.Cancel)

                Case MessageButtonEnum.AllVideo
                    Me.AddButton(MessageResultEnum.All)
                    Me.AddButton(MessageResultEnum.Video)
            End Select
        End Sub

        Private Sub AddButton(ByVal ClickResult As MessageResultEnum)
            Dim btn As New MessageButton

            With btn
                .Size = New System.Drawing.Size(ButtonWidth, ButtonHeight)
                .ClickResult = ClickResult
            End With

            AddHandler btn.Click, AddressOf MessageButton_Click

            Me.Buttons.Add(btn)
            Me.Controls.Add(btn)

            'Die Location wir abhngig von der Anzahl der Buttons festgelegt
            Dim Count As Int16 = Buttons.Count

            'Gibt die horizontale Startposition der Buttons an,
            'wobei jeder weitere Button um die Buttonbreite und
            'den horizontalen Abstand nach rechts verschoben wird
            Dim HStartPos As Int16 = ((Me.ClientSize.Width / 2) - ((ButtonWidth * (Count / 2)) + (HDistance * ((Count / 2) - 0.5))))
            Dim VStartPos As Int16 = Me.ClientSize.Height - ButtonHeight - VDistance

            For Each Button As Button In Buttons
                Button.Location = New System.Drawing.Point(HStartPos + ((ButtonWidth + HDistance) * Buttons.IndexOf(Button)), VStartPos)
            Next
        End Sub

        Private Sub MessageButton_Click(ByVal ClickResult As MessageResultEnum)
            Me.Result = ClickResult
            Me.Close()
        End Sub
#End Region

        'MessageButton Klasse die den Standard Button
        'um ein ClickResultat und ein eigenes Click-Event
        'erweitert
        Private Class MessageButton
            Inherits Button

            Private _clickresult As MessageResultEnum
            Public Shadows Event Click(ByVal Result As MessageResultEnum)

            Private Sub MyBase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Click
                RaiseEvent Click(Me.ClickResult)
            End Sub

            Public Sub New()
                MyBase.New()

                'Diese Buttons werden immer im XP-Style angezeigt
                Me.FlatStyle = FlatStyle.System
            End Sub

            Public Property ClickResult() As MessageResultEnum
                Get
                    Return _clickresult
                End Get
                Set(ByVal Value As MessageResultEnum)
                    Me._clickresult = Value

                    'Abhngig vom ClickResult
                    'wird die Beschriftung gewhlt
                    Select Case Value
                        Case MessageResultEnum.Add
                            Me.Text = "Hinzufgen"
                        Case MessageResultEnum.All
                            Me.Text = "Alle"
                        Case MessageResultEnum.Cancel
                            Me.Text = "Abbrechen"
                        Case MessageResultEnum.Many
                            Me.Text = "Mehrere Neu"
                        Case MessageResultEnum.None
                            Me.Text = String.Empty
                        Case MessageResultEnum.OK
                            Me.Text = "OK"
                        Case MessageResultEnum.One
                            Me.Text = "Eines Neu"
                        Case MessageResultEnum.Video
                            Me.Text = "Nur Video"
                    End Select
                End Set
            End Property
        End Class

    End Class
#End Region
End Class

Public Enum MessageButtonEnum
    'Ein Projekt mit vielen Streams, oder mehrere Projekte
    OneMany
    'Streams dem Projekt hinzufgen, ein neues Projekt, oder mehrere neue Projekte
    AddOne
    AddOneMany
    Ok
    OkCancel
    AllVideo
End Enum

Public Enum MessageResultEnum
    None
    Add
    All
    Cancel
    One
    Video
    OK
    Many
End Enum

Public Enum MessageIconEnum
    None
    Exclamation
    Information
    Question
    [Stop]
End Enum


