Imports System.IO
Namespace OUTPUT
    Public Class ProjectProcessing
        Public Shared LOGFile As String
        Public Shared Out As StreamWriter
        Private Shared WorkingProcess As System.Diagnostics.Process

        Private Shared ProcessType As OUTPUT.ProjectProcessing.Type

        Public Shared Sub Start(ByVal Arguments As String, ByVal Process As OUTPUT.ProjectProcessing.Type)
            WorkingProcess = New System.Diagnostics.Process
            ProcessType = Process

            With WorkingProcess.StartInfo
                Out.WriteLine()
                Out.WriteLine()

                Select Case Process
                    Case Process.dvdauthor
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine("                          DVDAuthor LOG")
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine()
                        .FileName = "dvdauthor"

                    Case Process.jpeg2yuv
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine("                          jpeg2yuv LOG")
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine()
                        .FileName = "cmd.exe"

                    Case Process.mpeg2enc
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine("                          mpeg2enc LOG")
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine()
                        .FileName = "mpeg2enc"

                    Case Process.mplex
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine("                           MPLEX LOG")
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine()
                        .FileName = "mplex"

                    Case Process.spumux
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine("                           spumux LOG")
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine()
                        .FileName = "cmd.exe"

                    Case Process.udrec
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine("                  Konvertierung von PES in ES")
                        Out.WriteLine("------------------------------------------------------------------")
                        Out.WriteLine()
                        .FileName = "Udrec"

                End Select

                .Arguments = Arguments
                .WorkingDirectory = Application.StartupPath
                .UseShellExecute = False
                .RedirectStandardOutput = True
                .RedirectStandardError = True
                .RedirectStandardInput = True
                .CreateNoWindow = True
            End With

            Out.WriteLine(Arguments)
            Out.WriteLine()
            Out.WriteLine()

            Dim thrLogFile As System.Threading.Thread

            WorkingProcess.Start()

            Resync = 0

            thrLogFile = New System.Threading.Thread(AddressOf Readline)
            thrLogFile.IsBackground = True
            thrLogFile.Start()

            Do
                Application.DoEvents()

                If LOG.LogDialog.Status = ProcessStatusEnum.Abort _
                OrElse LOG.LogDialog.Status = ProcessStatusEnum.Error Then
                    If Not WorkingProcess.HasExited Then WorkingProcess.Kill()
                    Exit Do
                ElseIf WorkingProcess.HasExited Then
                    Exit Do
                End If

                Threading.Thread.Sleep(100)
            Loop

            Do While thrLogFile.IsAlive
                Application.DoEvents()
                Threading.Thread.Sleep(100)
            Loop

            thrLogFile.Join()
            Application.DoEvents()
        End Sub

        Private Shared Sub Readline()
            Dim OutputReader As StreamReader

            Select Case ProcessType
                Case Type.udrec
                    OutputReader = WorkingProcess.StandardOutput
                Case Type.mplex, Type.dvdauthor, Type.jpeg2yuv, Type.mpeg2enc, Type.spumux
                    OutputReader = WorkingProcess.StandardError
            End Select

            Dim strLine As String = OutputReader.ReadLine

            Try
                Do While strLine.Length >= 0
                    strLine = OutputReader.ReadLine
                    Select Case ProcessType
                        Case Type.dvdauthor
                            Dim d As New WriteLine(AddressOf Dvdauthor)
                            LOG.LogDialog.Invoke(d, New Object() {strLine})

                        Case Type.jpeg2yuv
                            Dim d As New WriteLine(AddressOf Jpeg2yuv)
                            LOG.LogDialog.Invoke(d, New Object() {strLine})

                        Case Type.mpeg2enc
                            Dim d As New WriteLine(AddressOf Mpeg2enc)
                            LOG.LogDialog.Invoke(d, New Object() {strLine})

                        Case Type.mplex
                            Dim d As New WriteLine(AddressOf Mplex)
                            LOG.LogDialog.Invoke(d, New Object() {strLine})

                        Case Type.spumux
                            Dim d As New WriteLine(AddressOf Spumux)
                            LOG.LogDialog.Invoke(d, New Object() {strLine})

                        Case Type.udrec
                            Dim d As New WriteLine(AddressOf Udrec)
                            LOG.LogDialog.Invoke(d, New Object() {strLine})

                    End Select
                Loop
            Catch 'ex As Exception
                'Console.WriteLine(ex.ToString)
            End Try
        End Sub

        Private Delegate Sub WriteLine(ByVal strLine As String)

        Private Shared Starttime As TimeSpan
        Private Shared Resync As Int16

        Private Shared Sub Udrec(ByVal strLine As String)
            Dim Text As String
            Dim TextLang As String
            Dim GopTime As TimeSpan
            Dim Time As String

            'Dem LOG-File wird eine Zeile hinzugefgt
            Out.WriteLine(strLine)
            TextLang = Mid(strLine, 10)
            Text = Mid(strLine, 23)

            If Text = "video resync" Then
                Resync += 1
                GopTime = GetTimespan(Mid(strLine, 10, 11))

                If Resync > 1 Then
                    Time = GetTime(Starttime, GopTime)
                    LOG.WriteLine(Time & " Video Resync", Images.Icon.Error)
                Else
                    Starttime = GopTime
                End If

            ElseIf Text = "video split" Then
                GopTime = GetTimespan(Mid(strLine, 10, 11))
                Time = GetTime(Starttime, GopTime)
                LOG.WriteLine(Time & " Video-Schnittpunkt gefunden, Zeit wird zurckgesetzt!", Images.Icon.Info)
                Starttime = GopTime

            ElseIf Text = "audio split" Then
                GopTime = GetTimespan(Mid(strLine, 10, 11))
                Time = GetTime(Starttime, GopTime)
                LOG.WriteLine(Time & " Audio-Schnittpunkt gefunden, Zeit wird zurckgesetzt!", Images.Icon.Info)
                Starttime = GopTime

            ElseIf Text = "corrupt audio frame(s)" Then
                GopTime = GetTimespan(Mid(strLine, 10, 11))
                Time = GetTime(Starttime, GopTime)
                LOG.WriteLine(Time & " Fehlerhafte Audio Frames", Images.Icon.Error)

            ElseIf Text.StartsWith("AC3 PES: sync block too long") Then
                GopTime = GetTimespan(Mid(strLine, 10, 11))
                Time = GetTime(Starttime, GopTime)
                LOG.WriteLine(Time & " AC3 Sync Block zu lang", Images.Icon.Error)

            ElseIf Text.StartsWith("MP2 PES: sync block too long") Then
                GopTime = GetTimespan(Mid(strLine, 10, 11))
                Time = GetTime(Starttime, GopTime)
                LOG.WriteLine(Time & " MP2 Sync Block zu lang", Images.Icon.Error)

            ElseIf TextLang.StartsWith("AC3 PES: sync block too long") Then
                LOG.WriteLine("AC3 Sync Block zu lang", Images.Icon.Error)

            ElseIf TextLang.StartsWith("MP2 PES: sync block too long") Then
                LOG.WriteLine("MP2 Sync Block zu lang", Images.Icon.Error)

            End If
        End Sub

        Private Shared Function GetTime(ByVal StartTime As TimeSpan, ByVal EndTime As TimeSpan) As String
            Dim Time As String = String.Empty
            Dim newTime As TimeSpan

            If TimeSpan.Compare(StartTime, EndTime) = 1 Then
                EndTime.Add(TimeSpan.FromDays(1))
            End If

            newTime = EndTime.Subtract(StartTime)
            Time = Format(newTime.Hours, "00") & ":" & _
                   Format(newTime.Minutes, "00") & ":" & _
                   Format(newTime.Seconds, "00") & "," & _
                   Format(newTime.Milliseconds / 10, "00")
            Return Time
        End Function

        Private Shared Function GetTimespan(ByVal Time As String) As TimeSpan
            Dim GopTime As TimeSpan
            Dim TimeParts(2) As String

            Try
                GopTime = TimeSpan.Parse(Time)
            Catch
                Dim Tage As Int16
                Dim Stunden As Int16

                TimeParts = Time.Split(":")

                Tage = TimeParts(0) / 24
                Stunden = TimeParts(0) Mod 24

                Time = String.Format("{0:d2}.{1:d2}:{2}:{3}", Tage, Stunden, TimeParts(1), TimeParts(2))
                GopTime = TimeSpan.Parse(Time)
            End Try

            Return GopTime
        End Function

        Private Shared Sub Mplex(ByVal strLine As String)
            'Dem LOG-File wird eine Zeile hinzugefgt
            Out.WriteLine(strLine)
            If strLine = "**ERROR: [???] Unrecogniseable file(s)... exiting." Then
                LOG.EmptyLine()
                LOG.WriteLine("Die angegebenen Dateien knnen nicht verarbeitet werden!", Images.Icon.Error)
                LOG.LogDialog.Status = ProcessStatusEnum.Error
            End If
        End Sub

        Private Shared Sub Jpeg2yuv(ByVal strLine As String)
            'Dem LOG-File wird eine Zeile hinzugefgt
            Out.WriteLine(strLine)
        End Sub

        Private Shared Sub Mpeg2enc(ByVal strLine As String)
            'Dem LOG-File wird eine Zeile hinzugefgt
            Out.WriteLine(strLine)
        End Sub

        Private Shared Sub Spumux(ByVal strLine As String)
            'Dem LOG-File wird eine Zeile hinzugefgt
            Out.WriteLine(strLine)
        End Sub

        'Erstellen der DVD-Struktur und Auswertung es LOG's
        Private Shared FixingVOBU As Boolean = False

        Private Shared Sub Dvdauthor(ByVal strLine As String)
            'Dem LOG-File wird eine Zeile hinzugefgt
            Out.WriteLine(strLine)

            If strLine = "ERR:  Error writing data" Then
                LOG.EmptyLine()
                LOG.WriteLine("Fehler beim schreiben der Daten!", Images.Icon.Error)
                LOG.LogDialog.Status = ProcessStatusEnum.Error

            ElseIf strLine = "ERR: Audio pts moves backwards; please remultiplex input." Then
                LOG.EmptyLine()
                LOG.WriteLine("Audio Zeitstempel laufen rckwrts!", Images.Icon.Error)
                LOG.WriteLine("Bitte die Ausgangsdaten neu multiplexxen.", Images.Icon.None)
                LOG.LogDialog.Status = ProcessStatusEnum.Error

            ElseIf strLine.StartsWith("ERR:") Then
                LOG.EmptyLine()
                LOG.WriteLine("DVDauthor hat einen unbekannten Fehler verursacht!", Images.Icon.Error)
                LOG.WriteLine("Details entnehmen Sie bitte der LOG-Datei", Images.Icon.None)
                LOG.LogDialog.Status = ProcessStatusEnum.Error

            ElseIf strLine.StartsWith("STAT: Picking VTS") Then
                LOG.WriteLine("Erstelle VTS-Struktur " & Right(strLine, 2), Images.Icon.Info)

            ElseIf strLine.StartsWith("STAT: Processing") Then
                Dim FileName As String = Mid(strLine, 18, strLine.Length - 20)
                Dim length As Int32 = New System.IO.FileInfo(FileName).Length / (1024 ^ 2)
                LOG.LogDialog.ProgressMax = length

            ElseIf strLine.StartsWith("STAT: VOBU") Then
                Dim rows As String()
                rows = strLine.Split(" ")
                Dim length As Int16 = Left(rows(4), rows(4).Length - 3)
                LOG.LogDialog.ProgressValue = length

            ElseIf strLine.StartsWith("STAT: fixing VOBU") Then
                If Not FixingVOBU Then
                    FixingVOBU = True
                    LOG.WriteLine("Fixiere VOBU", Images.Icon.Info)
                End If

                Dim rows As String() = strLine.Split(" ")
                Dim length As Int16 = Left(rows(4), rows(4).Length - 2)
                LOG.LogDialog.ProgressValue = length

            ElseIf strLine.StartsWith("STAT: fixed") Then
                FixingVOBU = False
                LOG.LogDialog.ProgressValue = 0

            ElseIf strLine = "INFO: dvdauthor creating table of contents" Then
                LOG.WriteLine("Erstelle IFO-Dateien", Images.Icon.Info)
            End If
        End Sub

        Public Enum Type
            dvdauthor
            jpeg2yuv
            mpeg2enc
            mplex
            spumux
            udrec
        End Enum
    End Class
End Namespace

