Imports System.Xml
Imports System.IO

Namespace OUTPUT
    Public Class XMLBatchFile
        Public Shared Sub Save(ByVal Projects As ArrayList, ByVal XMLFile As String)
            'ScanPlace Order Describer Version 1.0
            Dim Writer As New XmlTextWriter(XMLFile, System.Text.Encoding.Default)

            Dim FilmCounter As Int16 = 0

            With Writer
                .Formatting = Formatting.Indented
                .Indentation = 4 'Bestimmt die Einrckung jedes Elementes
                .WriteStartDocument()
                .WriteStartElement("Muxxi")
                .WriteAttributeString("Type", "Projects")
                .WriteAttributeString("Version", Muxxi.Settings.Programm.Name)
                .WriteStartElement("Projects")

                For Each Project As Data.Project In Projects
                    If Not CType(Project.Movies(0), DATA.Movie).Video.FullPath = String.Empty Then
                        .WriteStartElement("Project")
                        .WriteElementString("Text", Project.Text)

                        'Individuelle Einstellungen
                        .WriteElementString("Output", Project.OutputPath)
                        .WriteElementString("Type", Project.Type)
                        .WriteElementString("KeepDVDStructure", Project.KeepDVDStructure)
                        .WriteElementString("CreateDVDMenu", Project.CreateDVDMenu)

                        'Streams
                        .WriteStartElement("Movies")
                        For Each Movie As Data.Movie In Project.Movies
                            .WriteStartElement("Movie")
                            .WriteElementString("Text", Movie.Text)
                            .WriteElementString("InputFolder", Movie.InputFolder)
                            .WriteElementString("InputType", Movie.InputType)
                            .WriteElementString("Video", Movie.Video.FullPath)

                            .WriteElementString("FilmLength", Movie.FilmLength)
                            .WriteElementString("ChapterLength", Movie.ChapterLength)
                            .WriteElementString("ChapterDialog", Movie.ChapterDialog)
                            .WriteElementString("GenerateIDD", Movie.GenerateIDD)
                            .WriteElementString("VSplit", Movie.VSplit)
                            .WriteElementString("ASplit", Movie.ASplit)


                            'Audios
                            .WriteStartElement("Audios")
                            For Each Audio As Data.Audio In Movie.Audios
                                .WriteStartElement("Audio")
                                .WriteElementString("FullPath", Audio.FullPath)
                                .WriteElementString("Language", Audio.Language.Code)
                                .WriteEndElement()
                            Next
                            .WriteEndElement()
                            .WriteEndElement()
                        Next
                        .WriteEndElement()
                        .WriteEndElement()
                        FilmCounter += 1
                    End If
                Next
                .WriteEndElement()
                .WriteEndDocument()
                .Close()
            End With

            If FilmCounter = 0 Then File.Delete(XMLFile)
        End Sub

        Public Shared Sub Save(ByVal Project As Data.Project, ByVal XMLFile As String)
            Dim Projects As New ArrayList
            Projects.Add(Project)
            Save(Projects, XMLFile)
        End Sub

        Public Shared Function Load(ByVal XMLFile As String) As ArrayList
            'Zuerst wird berprft, ob das XMLFile besteht
            'Ist die Datei nicht vorhanden, wird eine leere
            'ArrayList zurckgegeben
            If Not File.Exists(XMLFile) Then Return New ArrayList

            'Es wird die gewnschte Datei geffnet und berprft
            'ob es sich um eine gltige Vorlage handelt. Auerdem
            'wird die Version der Vorlage berprft und danach der
            'passende Parser gestartet.
            Dim tmpDocument As New XmlDocument
            Dim tmpMainNode As XmlElement

            Dim Projects As New ArrayList

            tmpDocument.Load(XMLFile)

            Dim nodProjects As XmlNode

            'Es wird der Bereich 'Controls' aus dem XML-File ausgelesen und
            'die entsprechenden Elemente in der OrderArea erstellt
            nodProjects = tmpDocument.DocumentElement.Item("Projects")
            Dim curNode As XmlNode

            'Es wird der Bereich 'Controls' aus dem XML-File ausgelesen und
            'die entsprechenden Elemente in der Designarea erstellt

            For Each curNode In nodProjects
                Dim Project As New Data.Project
                Project.Text = curNode.Item("Text").InnerText

                'Individuelle Einstellungen
                Project.OutputPath = curNode.Item("Output").InnerText
                Project.Type = curNode.Item("Type").InnerText
                Project.KeepDVDStructure = curNode.Item("KeepDVDStructure").InnerText
                Project.CreateDVDMenu = curNode.Item("CreateDVDMenu").InnerText

                Dim nodStreams As XmlNode = curNode.Item("Movies")
                Dim nodStream As XmlNode
                'Movies
                For Each nodStream In nodStreams
                    Dim Movie As New Muxxi.Data.Movie

                    Movie.Text = nodStream.Item("Text").InnerText
                    Movie.InputFolder = nodStream.Item("InputFolder").InnerText
                    Movie.InputType = nodStream.Item("InputType").InnerText
                    Movie.Video.FullPath = nodStream.Item("Video").InnerText()

                    Movie.FilmLength = nodStream.Item("FilmLength").InnerText
                    Movie.ChapterLength = nodStream.Item("ChapterLength").InnerText
                    Movie.ChapterDialog = nodStream.Item("ChapterDialog").InnerText
                    Movie.GenerateIDD = nodStream.Item("GenerateIDD").InnerText
                    Movie.VSplit = nodStream.Item("VSplit").InnerText
                    Movie.ASplit = nodStream.Item("ASplit").InnerText

                    'Audios
                    Dim nodAudios As XmlNode = nodStream.Item("Audios")
                    Dim nodAudio As XmlNode

                    For Each nodAudio In nodAudios
                        Dim Audio As New DATA.Audio(nodAudio.Item("FullPath").InnerText, Muxxi.DATA.LanguageList.GetLanguageByCode(nodAudio.Item("Language").InnerText))
                        Movie.AddAudio(Audio)
                    Next
                    Project.AddMovie(Movie)
                Next
                Projects.Add(Project)
            Next

            Return Projects
        End Function

        Public Shared Sub AddProject(ByVal Project As Data.Project, ByVal XMLFile As String, ByVal Position As XMLBatchFile.Position)
            Dim Projects As New ArrayList
            Projects.Add(Project)
            XMLBatchFile.AddProjects(Projects, XMLFile, Position)
        End Sub

        Public Shared Sub AddProjects(ByVal Projects As ArrayList, ByVal XMLFile As String, ByVal Position As XMLBatchFile.Position)
            Dim Saved As ArrayList = XMLBatchFile.Load(XMLFile)

            Select Case Position
                Case Position.First
                    Projects.AddRange(Saved)
                    XMLBatchFile.Save(Projects, XMLFile)
                Case Position.Last
                    Saved.AddRange(Projects)
                    XMLBatchFile.Save(Saved, XMLFile)
            End Select
        End Sub

        Public Enum Position
            First
            Last
        End Enum
    End Class
End Namespace