Namespace Settings
    Public Class Output
        Public Shared Type As DATA.ProjectType
        Public Shared Folder As String
        Public Shared AutoSubfolder As Boolean
    End Class

    Public Class Temp
        Public Shared Use As Boolean
        Public Shared Folder As String
        Public Shared DeleteES As Boolean
        Public Shared DeleteMPG As Boolean
        Public Shared DeleteDVD As Boolean
    End Class

    Public Class DVD
        Public Shared FilmLength As Int16
        Public Shared ChapterLength As Int16
        Public Shared KeepDVDStructure As Boolean 'Bei 'FALSE' werden VIDEO_TS und AUDIO_TS gelscht, wenn vorhanden
        Public Shared SaveEPGinOutput As Boolean 'Speicher die EPG.txt im Output Ordner
        Public Shared UseDVDauthor_0_6_10 As Boolean
    End Class

    Public Class DVDMenu
        Public Shared Background As String
        Public Shared BackgroundColor As Color
        Public Shared TitleColor As Color
        Public Shared ButtonColor As Color
        Public Shared NormalColor As Color
        Public Shared HighlightColor As Color
        Public Shared SelectColor As Color
        Public Shared ShowDVDTitle As Boolean
        Public Shared PauseAfterTitle As Int16
    End Class

    Public Class Udrec
        Public Shared RewriteGTC As Boolean
        Public Shared GenerateIDD As Boolean
        Public Shared UseMinSyncCount As Boolean
        Public Shared MinSyncCount As Int16
        Public Shared VSplit As Int16
        Public Shared ASplit As Int16
    End Class

    Public Class Automatical
        Public Shared ProcessAudio As Recorded
        Public Shared ReplaceMP2 As Boolean
        Public Shared Modus As Boolean = False

        'Aufgenommene Audios lt. JtG-LOG
        <Flags()> _
        Public Enum Recorded
            None = 0
            Standard = 1
            Original = 2
            AC3 = 4
        End Enum
    End Class

    Public Class LOG
        Public Shared SaveAndCloseLOG As Boolean
        Public Shared MinimizeLOG As Boolean
        Public Shared Folder As SaveIn

        'Speicherort der LOG-Dateien
        Public Enum SaveIn
            Output
            Input
            Temp
        End Enum
    End Class

    Public Class Tipps
        Private Shared _shift_onlyvideo As Boolean

        Public Shared Property SHIFT_OnlyVideo() As Boolean
            Get
                Return _shift_onlyvideo
            End Get
            Set(ByVal Value As Boolean)
                _shift_onlyvideo = Value
                Settings.INI.Write("Tipps", "SHIFT for OnlyVideo", Value)
            End Set
        End Property
    End Class

    Public Class Programm
        Public Shared Name As String = String.Format("{0} V1.10.044", Application.ProductName)
        Public Shared XMLBatchFile As String = Application.StartupPath & "\Projects.xml"
    End Class

    Public Class Functions
        Public Shared Sub Read()
            'Es werden verschiedene Eigenschaften aus der INI geladen.
            'Sollte die INI nicht vorhanden sein, oder aus irgendeinem
            'Grund ein Eintrag fehlen, wird der jeweilige Standardwert
            'festgelegt

            Dim Section As String

            '[General]
            Section = "General"
            Output.Type = Settings.INI.Read(Section, "Output Type", DATA.ProjectType.DVD)

            '[Output]
            Section = "Output"
            Output.Folder = Settings.INI.Read(Section, "Output Folder", "DVD")
            Output.AutoSubfolder = Settings.INI.Read(Section, "Auto Subfolder", False)

            '[Temp]
            Section = "Temp"
            Temp.Use = Settings.INI.Read(Section, "Use Temp Folder", False)
            Temp.Folder = Settings.INI.Read(Section, "Temp Folder", String.Empty)
            Temp.DeleteES = Settings.INI.Read(Section, "Delete ES-Files", True)
            Temp.DeleteMPG = Settings.INI.Read(Section, "Delete MPG-File", True)
            Temp.DeleteDVD = Settings.INI.Read(Section, "Delete DVD-Structure", True)

            '[DVD]
            Section = "DVD"
            DVD.FilmLength = Settings.INI.Read(Section, "Film length", 210)
            DVD.ChapterLength = Settings.INI.Read(Section, "Chapter length", 5)
            DVD.KeepDVDStructure = Settings.INI.Read(Section, "Keep DVD Structure", False)
            DVD.SaveEPGinOutput = Settings.INI.Read(Section, "Save EPG in Output", False)
            DVD.UseDVDauthor_0_6_10 = Settings.INI.Read(Section, "Use DVDauthor 0.6.10", False)

            '[DVD-Menu]
            Section = "DVD-Menu"
            DVDMenu.Background = Settings.INI.Read(Section, "Background Image", String.Empty)
            DVDMenu.BackgroundColor = Color.FromArgb(Settings.INI.Read(Section, "Background Color", Color.Black.ToArgb))
            DVDMenu.TitleColor = Color.FromArgb(Settings.INI.Read(Section, "Title Color", Color.White.ToArgb))
            DVDMenu.ButtonColor = Color.FromArgb(Settings.INI.Read(Section, "Button Color", Color.White.ToArgb))
            DVDMenu.HighlightColor = Color.FromArgb(Settings.INI.Read(Section, "Highlight Color", Color.Red.ToArgb))
            DVDMenu.SelectColor = Color.FromArgb(Settings.INI.Read(Section, "Selected Color", Color.Yellow.ToArgb))
            DVDMenu.ShowDVDTitle = Settings.INI.Read(Section, "Show DVD-Title", True)
            DVDMenu.PauseAfterTitle = Settings.INI.Read(Section, "Pause after Title", 5)

            '[UDREC PES Streams]
            Section = "UDREC"
            Udrec.RewriteGTC = Settings.INI.Read(Section, "Rewrite GTC", True)
            Udrec.GenerateIDD = Settings.INI.Read(Section, "Generate IDD", False)
            Udrec.UseMinSyncCount = Settings.INI.Read(Section, "Use Min Sync Count", False)
            Udrec.MinSyncCount = Settings.INI.Read(Section, "Min Sync Count", 20)
            Udrec.VSplit = Settings.INI.Read(Section, "Video-Split", "-1")
            Udrec.ASplit = Settings.INI.Read(Section, "Audio-Split", "-1")

            '[automatische Verarbeitung]
            Section = "Automatic"
            Automatical.ProcessAudio = Settings.INI.Read(Section, "Process Audio", 7)
            Automatical.ReplaceMP2 = Settings.INI.Read(Section, "Replace MP2", False)

            '[LOG]
            Section = "LOG"
            LOG.SaveAndCloseLOG = Settings.INI.Read(Section, "Save and Close Log", False)
            LOG.MinimizeLOG = Settings.INI.Read(Section, "Minimize Log at start", False)
            LOG.Folder = Settings.INI.Read(Section, "Save Log in", LOG.SaveIn.Output)

            '[Tipps]
            Section = "Tipps"
            Tipps.SHIFT_OnlyVideo = Settings.INI.Read(Section, "SHIFT for OnlyVideo", False)

            Call Write()
            Call Images.Load()
        End Sub

        Public Shared Sub Write()
            Dim Section As String

            '[General]
            Section = "General"
            Settings.INI.Write(Section, "Output Type", Output.Type)
            'Es wird nur der letzte Verarbeitungstyp gespeichert

            '[Output]
            Section = "Output"
            Settings.INI.Write(Section, "Output Folder", Output.Folder)
            Settings.INI.Write(Section, "Auto Subfolder", Output.AutoSubfolder)

            '[Temp]
            Section = "Temp"
            Settings.INI.Write(Section, "Use Temp Folder", Temp.Use)
            Settings.INI.Write(Section, "Temp Folder", Temp.Folder)
            Settings.INI.Write(Section, "Delete ES-Files", Temp.DeleteES)
            Settings.INI.Write(Section, "Delete MPG-File", Temp.DeleteMPG)
            Settings.INI.Write(Section, "Delete DVD-Structure", Temp.DeleteDVD)

            '[DVD]
            Section = "DVD"
            Settings.INI.Write(Section, "Film Length", DVD.FilmLength)
            Settings.INI.Write(Section, "Chapter Length", DVD.ChapterLength)
            Settings.INI.Write(Section, "Keep DVD Structure", DVD.KeepDVDStructure)
            Settings.INI.Write(Section, "Save EPG in Output", DVD.SaveEPGinOutput)
            Settings.INI.Write(Section, "Use DVDauthor 0.6.10", DVD.UseDVDauthor_0_6_10)

            '[DVD-Menu]
            Section = "DVD-Menu"
            Settings.INI.Write(Section, "Background Image", DVDMenu.Background)
            Settings.INI.Write(Section, "Background Color", DVDMenu.BackgroundColor.ToArgb)
            Settings.INI.Write(Section, "Title Color", DVDMenu.TitleColor.ToArgb)
            Settings.INI.Write(Section, "Button Color", DVDMenu.ButtonColor.ToArgb)
            Settings.INI.Write(Section, "Highlight Color", DVDMenu.HighlightColor.ToArgb)
            Settings.INI.Write(Section, "Selected Color", DVDMenu.SelectColor.ToArgb)
            Settings.INI.Write(Section, "Show DVD-Title", DVDMenu.ShowDVDTitle)
            Settings.INI.Write(Section, "Pause after Title", DVDMenu.PauseAfterTitle)

            '[UDREC PES Streams]
            Section = "UDREC"
            Settings.INI.Write(Section, "Rewrite GTC", Udrec.RewriteGTC)
            Settings.INI.Write(Section, "Generate IDD", Udrec.GenerateIDD)
            Settings.INI.Write(Section, "Use Min Sync Count", Udrec.UseMinSyncCount)
            Settings.INI.Write(Section, "Min Sync Count", Udrec.MinSyncCount)
            Settings.INI.Write(Section, "Video-Split", Udrec.VSplit)
            Settings.INI.Write(Section, "Audio-Split", Udrec.ASplit)

            '[automatische Verarbeitung]
            Section = "Automatic"
            Settings.INI.Write(Section, "Process Audio", Automatical.ProcessAudio)
            Settings.INI.Write(Section, "Replace MP2", Automatical.ReplaceMP2)

            '[LOG]
            Section = "LOG"
            Settings.INI.Write(Section, "Save and Close Log", LOG.SaveAndCloseLOG)
            Settings.INI.Write(Section, "Minimize Log at start", LOG.MinimizeLOG)
            Settings.INI.Write(Section, "Save Log in", LOG.Folder)
        End Sub
    End Class
End Namespace
