Namespace UI
    Public Class LogListItem
        Inherits System.Windows.Forms.Control

        Private Sub InitializeComponent()
        End Sub

        Private _image As Image
        Private _time As String
        Private _text As String

        Private _icon As Images.Icon

        Public Sub New()
            MyBase.New()
            Me._time = Now.ToLongTimeString
        End Sub

        Public Sub NoTime()
            Me._time = ""
        End Sub

        Public Shadows Property Text() As String
            Get
                Return Me._text
            End Get
            Set(ByVal Value As String)
                _text = Value
            End Set
        End Property

        Public Overrides Function ToString() As String
            If Me._time = String.Empty Then
                Return "           " & Me._text
            Else
                Return Me._time & " - " & Me._text
            End If
        End Function

        Public WriteOnly Property Image() As Image
            Set(ByVal Value As Image)
                Me._image = Value
            End Set
        End Property

#Region " Alles was fr die Darstellung des LogListItem notwendig ist"
        Public Overrides Property BackColor() As Color
            Get
                Return MyBase.BackColor
            End Get
            Set(ByVal Value As Color)
                MyBase.BackColor = Value
            End Set
        End Property

        Public Overrides Property ForeColor() As Color
            Get
                Return MyBase.ForeColor
            End Get
            Set(ByVal Value As Color)
                MyBase.ForeColor = Value
            End Set
        End Property

        Public Property Icon() As Images.Icon
            Get
                Return Me._icon
            End Get
            Set(ByVal Value As Images.Icon)
                Me._icon = Value
            End Set
        End Property

        Protected Overrides Sub onpaint(ByVal e As PaintEventArgs)
            e.Graphics.FillRectangle(New SolidBrush(BackColor), ClientRectangle)

            e.Graphics.DrawImage(Me._image, 0, 0)
            e.Graphics.DrawString(Me._time, Font, New SolidBrush(ForeColor), 20, 0)
            e.Graphics.DrawString(Me._text, Font, New SolidBrush(ForeColor), 70, 0)
        End Sub
#End Region

    End Class
End Namespace