Public Class ProjectCollection
    Inherits CollectionBase

    Public Sub New(ByVal Owner As Control)
        Me.owner = Owner
    End Sub

    Private owner As Control

    Default Property Item(ByVal Index As Integer) As Data.Project
        Get
            Return CType(List(Index), Data.Project)
        End Get
        Set(ByVal Value As Data.Project)
            List(Index) = Value
            Me.owner.Invalidate()
        End Set
    End Property

    Public Function Add(ByVal Item As Data.Project) As Integer
        Dim result As Integer
        result = List.Add(Item)
        'AddHandler Item.MouseDown, AddressOf OnMouseDown
        Me.owner.Invalidate()
        Return result
    End Function

    Public Function IndexOf(ByVal Project As Data.Project) As Integer
        Return List.IndexOf(Project)
    End Function


    Public Sub Insert(ByVal Index As Integer, ByVal Project As Data.Project)
        List.Insert(Index, Project)
        Me.owner.Invalidate()
    End Sub


    Public Sub Remove(ByVal Project As Data.Project)
        List.Remove(Project)
        Me.owner.Invalidate()
    End Sub


    Public Function Contains(ByVal Project As Data.Project) As Boolean
        Return List.Contains(Project)
    End Function


    Public Shadows Sub Clear()
        MyBase.Clear()
        Me.owner.Invalidate()
    End Sub

    Public Event MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs)
    Protected Friend Sub OnMouseDown(ByVal sender As Object, ByVal e As MouseEventArgs)
        RaiseEvent MouseDown(sender, e)
    End Sub

    Protected Friend Sub OnCloseButtonClick(ByVal sender As Object)
        If TypeOf sender Is Data.Project Then
            Me.Remove(sender)
            Me.owner.Invalidate()
        End If
    End Sub
End Class

