Namespace UI
    Public Class ProjectListItem
        Inherits System.Windows.Forms.Control

        Private WithEvents _project As Data.Project

        Public Sub New(ByVal Project As Data.Project)
            Me._project = Project
            InitializeComponent()
        End Sub

        Private Sub InitializeComponent()
            Me.AllowDrop = True
            Me.BackColor = Color.White
            Me.ForeColor = Color.Black
        End Sub

        Public ReadOnly Property Project() As Data.Project
            Get
                Return Me._project
            End Get
        End Property

        'Ansicht aktualisieren
        Private Sub _project_TextChanged() Handles _project.TextChanged
            Me.Invalidate()
        End Sub


#Region " Eigenschaften und Routinen, die fr das Aussehen verantwortlich sind"
        Private ShowBoarder As Boolean = False

        Private Function GetMoviesCount() As String
            Dim count As Int16 = Me.Project.Movies.Count
            Select Case count
                Case 0
                    Return "Kein"
                Case 1
                    Return "1 Film"
                Case Else
                    Return String.Format("{0} Filme", count)
            End Select
        End Function

        Public Overrides Property BackColor() As Color
            Get
                Return MyBase.BackColor
            End Get
            Set(ByVal Value As Color)
                MyBase.BackColor = Value
            End Set
        End Property

        Public Overrides Property ForeColor() As Color
            Get
                Return MyBase.ForeColor
            End Get
            Set(ByVal Value As Color)
                MyBase.ForeColor = Value
            End Set
        End Property

        Public WriteOnly Property Selected() As Boolean
            Set(ByVal Value As Boolean)
                Select Case Value
                    Case True
                        Me.BackColor = SystemColors.InactiveBorder
                        Me.ShowBoarder = True
                    Case False
                        Me.BackColor = Color.White
                        Me.ShowBoarder = False
                End Select
            End Set
        End Property

        Protected Overrides Sub onpaint(ByVal e As PaintEventArgs)
            e.Graphics.FillRectangle(New SolidBrush(BackColor), ClientRectangle)
            If Me.ShowBoarder Then e.Graphics.DrawRectangle(New Pen(SystemColors.InactiveCaption), New Rectangle(0, 0, Me.Width - 1, Me.Height - 1))

            Dim drawFormat As New StringFormat
            drawFormat.FormatFlags = StringFormatFlags.NoWrap
            drawFormat.Trimming = StringTrimming.EllipsisCharacter

            e.Graphics.DrawString(Me.Project.Text, Font, New SolidBrush(ForeColor), New RectangleF(5, 0, 150, 20), drawFormat)

            e.Graphics.DrawString(Me.Project.Type.ToString, Font, New SolidBrush(ForeColor), 160, 0)
            e.Graphics.DrawString(Me.GetMoviesCount, Font, New SolidBrush(ForeColor), 190, 0)

            Dim drawPath As New StringFormat
            drawPath.FormatFlags = StringFormatFlags.NoWrap
            drawPath.Trimming = StringTrimming.EllipsisPath

            e.Graphics.DrawString(Me.Project.OutputPath, Font, New SolidBrush(ForeColor), New RectangleF(250, 0, Me.Width - 245, 20), drawPath)
        End Sub
#End Region

    End Class
End Namespace
